White space only
[ghc-hetmet.git] / boot
diff --git a/boot b/boot
index 78c9295..f47bdf6 100644 (file)
--- a/boot
+++ b/boot
@@ -1,32 +1,79 @@
-#! /bin/sh
-set -e
+#!/usr/bin/perl -w
+
+use strict;
+
+use Cwd;
+
+my %required_tag;
+
+$required_tag{"-"} = 1;
+
+while ($#ARGV ne -1) {
+    my $arg = shift @ARGV;
+
+    if ($arg =~ /^--required-tag=(.*)/) {
+        $required_tag{$1} = 1;
+    }
+    else {
+        die "Bad arg: $arg";
+    }
+}
+
+# Create libraries/*/{ghc.mk,GNUmakefile}
+system("/usr/bin/perl", "-w", "boot-pkgs") == 0
+    or die "Running boot-pkgs failed: $?";
+
+my $tag;
+my $dir;
+my $curdir;
+
+$curdir = &cwd()
+    or die "Can't find current directory: $!";
 
 # Check that we have all boot packages.
-for dir in `grep "^[^# ][^ ]*  *[^ ][^ ]*  *[^ ][^ ]*$" packages | sed "s/ .*//"`
-do
-    if test ! -f $dir/LICENSE
-    then
-        echo "Error: $dir/LICENSE doesn't exist." >&2
-        echo "Maybe you haven't done './darcs-all get'?" >&2
-        exit 1
-    fi
-done
+open PACKAGES, "< packages";
+while (<PACKAGES>) {
+    if (/^#/) {
+        # Comment; do nothing
+    }
+    elsif (/^([a-zA-Z0-9\/.-]+) +([^ ]+) +[^ ]+ +[^ ]+ +[^ ]+$/) {
+        $dir = $1;
+        $tag = $2;
+        
+        # If $tag is not "-" then it is an optional repository, so its
+        # absence isn't an error.
+        if (defined($required_tag{$tag})) {
+            # We would like to just check for an _darcs directory here,
+            # but in an lndir tree we avoid making _darcs directories,
+            # so it doesn't exist. We therefore require that every repo
+            # has a LICENSE file instead.
+            if (! -f "$dir/LICENSE") {
+                print STDERR "Error: $dir/LICENSE doesn't exist.\n";
+                die "Maybe you haven't done './darcs-all get'?";
+            }
+        }
+    }
+    else {
+        die "Bad line in packages file: $_";
+    }
+}
+close PACKAGES;
 
 # autoreconf everything that needs it.
-for dir in . libraries/*
-do
-    if test -f $dir/configure.ac
-    then
-        echo "Booting $dir"
-        ( cd $dir && autoreconf )
-    fi
-done
+foreach $dir (".", glob("libraries/*/")) {
+    if (-f "$dir/configure.ac") {
+        print "Booting $dir\n";
+        chdir $dir or die "can't change to $dir: $!";
+        system("autoreconf") == 0
+            or die "Running autoreconf failed with exitcode $?";
+        chdir $curdir or die "can't change to $curdir: $!";
+    }
+}
 
 # Alas, darcs doesn't handle file permissions, so fix a few of them.
-for f in boot darcs-all push-all validate
-do
-    if test -f $f
-    then
-        chmod +x $f
-    fi
-done
+for my $file ("boot", "darcs-all", "validate") {
+    if (-f $file) {
+        chmod 0755, $file
+            or die "Can't chmod 0755 $file: $!";
+    }
+}